# BEGIN COPYRIGHT
# *************************************************************************
# Licensed Materials - Property of IBM 
# 5724-L01, 5655-N53, 5724-I82, 5655-R15
# (C) Copyright IBM Corporation 2007, 2008, 2009. All rights reserved. 
# US Government Users Restricted Rights - Use, duplication, or disclosure
# restricted by GSA ADP Schedule Contract with IBM Corp.
# *************************************************************************
# END COPYRIGHT

# import related classes
import sys;
from java.lang import *;
import java.io.File as File;
import re;
import shutil;
import os;
import os.path;

print "*************************************************************************************"
print "start: init"
print ""

#DEFINE the WAS root directory.
rootInstallDir=System.getProperty("was.install.root") 

#DEFINE the REST Gateway EAR file location for both UNIX and Windows.
RestServiceGatewayEarFile=rootInstallDir + "/installableApps/RESTServiceGateway.ear"

# IF the OS is Windows;:
#    1. Replace the '/" with the windows path separator. 
#    2. pre-post affix a '"" to the fully qualified REST Gateway EAR file

if (System.getProperty("os.name").startswith("Windows")):
    RestServiceGatewayEarFile=RestServiceGatewayEarFile.replace('/','\\')
    RestServiceGatewayEarFile='"' + RestServiceGatewayEarFile + '"'

fileSeparator = System.getProperty("file.separator");
configUtilsScript = System.getProperty("was.install.root") + fileSeparator + "util" + fileSeparator + "config" + fileSeparator + "admin" + fileSeparator + "configUtils.py"
print "load configuration utils from ", configUtilsScript
execfile(configUtilsScript);

print ""
print "end: init"

def updateRESTGatewayApplication():
    print ""
    print "updating REST services gateway";
    print ""
		
		# Use the previously defined REST Gateway EAR file location.
    updateApplication("REST Services Gateway", "app", "[ -operation update -contents " + RestServiceGatewayEarFile + " -nopreCompileJSPs -distributeApp -validateinstall warn ]")      

    print "updated REST services gateway";
    print ""   
#endDef

def ConfigRESTGatewayServices(nodeName, serverName):
    print ""
    print "configuring REST services for node " + nodeName + "and server " + serverName;
    print ""

    if cellType == 'STANDALONE':
        print "Configuring the REST Gateway default services."
        AdminTask.updateRESTGatewayService(['-nodeName', nodeName, '-serverName', serverName, '-enable', 'true'])
        
    print "Configuring the REST Gateway SCA service."
    AdminTask.updateRESTGatewayService(['-nodeName', nodeName, '-serverName', serverName, '-type', '{com.ibm.bpm}SCA', '-version', '6.2.0.0', '-enable', 'true'])
    print "Configuring the REST Gateway Health Monitor service."
    AdminTask.updateRESTGatewayService(['-nodeName', nodeName, '-serverName', serverName, '-type', '{com.ibm.bpm}HealthMonitor', '-version', '6.2.0.0', '-enable', 'true'])
    print "Configuring the REST Gateway Service Connectivity Management Connectivity Server service."
    AdminTask.updateRESTGatewayService(['-nodeName', nodeName, '-serverName', serverName, '-type', '{com.ibm.ws.sibx.scmp.connectivityprovider}SibxConnectivityProviderServer', '-version', '7.0.0.0', '-enable', 'true'])

    print "configured REST services";
    print ""   
#endDef

def getRESTDeploymentTargets():
    print ""
    
    restDeploymentTargetsList = getObjectArray(AdminConfig.list("WBIRestDeploymentTarget"));
    
    print "The value of restDeploymentTargetsList is ", restDeploymentTargetsList
    print ""
    return  restDeploymentTargetsList;  
#endDef

def getRestWebModules(restDeploymentTarget):
    print ""

    webModulesList = getObjectArray(AdminConfig.list("WBIRestWebModule", restDeploymentTarget));
    
    print "The value of webModulesList is ", webModulesList
    print ""
    return  webModulesList; 
#endDef

def getRESTWebModule(contextID, webModuleName):
    print ""
    print "Look for the REST Web module with the context ID " + contextID + " and the name " + webModuleName;
    
    restDeploymentTargetsList = getRESTDeploymentTargets();
        
    for restDeploymentTarget in restDeploymentTargetsList:
        currentContextID = AdminConfig.showAttribute(restDeploymentTarget, "contextID");
        
        if currentContextID == contextID:               
            print "Found " +  restDeploymentTarget + " with the context ID " + currentContextID;
            webModulesList = getRestWebModules(restDeploymentTarget);
                    
            for webModule in webModulesList:
                currentWebModuleName = AdminConfig.showAttribute(webModule, "name"); 
                            
                if currentWebModuleName == webModuleName:
                    print "Found ", webModule
                    print ""
                    return webModule;
                    
    print "Cannot find the REST Web module"             
    print ""
#endDef


def refreshSystemRESTServices():
    print ""
    print "Refreshing the system REST services"
    print ""
    
    restDeploymentTargetsList = getRESTDeploymentTargets();
    
    for restDeploymentTarget in restDeploymentTargetsList:
        contextID = AdminConfig.showAttribute(restDeploymentTarget, "contextID");
        print "The current deployment target context ID is ", contextID 
        contextIDValues = contextID.split(":");
                
        webModulesList = getRestWebModules(restDeploymentTarget);
                
        for webModule in webModulesList:        
            updateWebModule(contextID, contextIDValues, webModule);
    print ""                
    print "Refreshed the system REST services"
#endDef

def updateWebModule(contextID, contextIDValues, webModule):
    print ""
    
    currentWebModuleName = AdminConfig.showAttribute(webModule, "name");
    print "The current Web module name is ", currentWebModuleName 
                
    if currentWebModuleName == "rest.gateway.war":
                    
        transportType = AdminConfig.showAttribute(webModule, "transportType");
        hostName = AdminConfig.showAttribute(webModule, "hostName");
        port = AdminConfig.showAttribute(webModule, "port");
        default = AdminConfig.showAttribute(webModule, "default");
        print "The value of transportType is ", transportType, " , hostName is ", hostName, " , port is ", port, " , default is ", default
                    
        if len(contextIDValues) == 6:               
            nodeName = contextIDValues[3];
            serverName = contextIDValues[5];
            print "The value of nodeName is ", nodeName, " - serverName is ", serverName
            
            print ""
            print "Reconfigure default REST endpoints"
            AdminConfig.remove(webModule);
            
            if cellType == 'STANDALONE':
                ConfigRESTGatewayServices(nodeName, serverName);
            elif (cellType == 'DISTRIBUTED') and (getLocalServerName() == serverName):
                ConfigRESTGatewayServices(nodeName, serverName);
            else:
                AdminTask.updateRESTGatewayService(['-nodeName', nodeName, '-serverName', serverName, '-enable', 'true'])
            
        elif len(contextIDValues) == 4:
            clusterName = contextIDValues[3];
            print "The value of clusterName is ", clusterName
            
            print ""
            print "Reconfigure default REST endpoints"
            AdminConfig.remove(webModule);
            AdminTask.updateRESTGatewayService(['-clusterName', clusterName, '-enable', 'true'])
            
        else:
            print ""
            print "The following context ID is not valid : ", contextID
            return
        
        print ""    
        print "Get the reconfigured Web module" 
        refreshedWebModule = getRESTWebModule(contextID, currentWebModuleName);
        
        if refreshedWebModule:
            print "Reset the attributes : " + " transportType " + transportType + " hostName " + hostName + " port " + port;                            
            AdminConfig.modify(refreshedWebModule, "[[transportType " + transportType + "] [hostName " + hostName + "] [port " + port + "]]");
            
            if not (default == None):
                print "Reset the attribute : " + " default " + default;                            
                AdminConfig.modify(refreshedWebModule, "[[default " + default + "]]");
            
            print "Attributes reset" ;
            print "";
        else:
            print "*************************************************************************************"
            print "Manually reset the system REST services attributes to " + " transportType " + transportType + " hostName " + hostName + " port "; 
            print "*************************************************************************************"
    elif currentWebModuleName == "scaRestServices.war":
        AdminConfig.remove(webModule);
    else:
        restEndpointList = getObjectArray(AdminConfig.list("WBIRestEndpoint", webModule));        
                
        for restEndpoint in restEndpointList:
            relativeURL = AdminConfig.showAttribute(restEndpoint, "relativeURL");
            print "The value of relativeURL is ", relativeURL;
            if (relativeURL == None):
                print "Set the attribute relativeURL to ''";                            
                AdminConfig.modify(restEndpoint, "[[relativeURL '']]");
            print AdminConfig.show(restEndpoint);            

    print ""                
#endDef

def migrateRESTGatewayServices():
    print ""
    print "migrating REST services configuration";
    print ""
   
    if (isApplicationInstalled("BSpaceITWidgets") == "True"):
        uninstallApplication("BSpaceITWidgets");
        
    if (isApplicationInstalled("SCA REST Services") == "True"):
        uninstallApplication("SCA REST Services");
        
    if (isApplicationInstalled("REST Services Gateway") == "True"):
        updateRESTGatewayApplication();
    elif (getCellType() == "STANDALONE"):        
        ConfigRESTGatewayServices(System.getProperty("local.node"), getLocalServerName());

    refreshSystemRESTServices();        

    print "migrated REST services configuration";
    print ""   
#endDef



print "*************************************************************************************"
print "start: REST services configuration migration"
print ""
try:
    cellType = getCellType();
    
    if cellType == 'STANDALONE':
        print "Migrating the stand-alone profile"
                
        migrateRESTGatewayServices();            
        
        AdminConfig.save();     
            
                                        
    elif cellType == 'DISTRIBUTED':
        print "Migrating the distributed (dmgr or customized) profile"
            # check whether the local node is a deployment manager Node
        isDMgrNode = isDMgrNode();
            
        if (isDMgrNode != "False"):
            migratedClusterName = System.getProperty("bpm.upgrade.cluster.name");
            print ""
            print "The value of migratedClusterName is ", migratedClusterName;
            
            if not (migratedClusterName) or (isEmptyString(migratedClusterName) == "True"):
                migrateRESTGatewayServices();
                ConfigRESTGatewayServices(System.getProperty("local.node"), getLocalServerName());
                                
                AdminConfig.save();        
            else:
                print "migrating a cluster"
            
                                
        else:        
            print "Migrating the distributed custom profile"           
            
    else:
        print "Unknown cell type"
except:
    print "Cannot migrate REST services configuration. The exception type is: ", sys.exc_type, ". The exception description is: ", sys.exc_value      
                
            
print 
print ""
print "end: REST services configuration migration"
print "*************************************************************************************"